package klassen;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *
 * Beschreibung
 *
 * @version 1.0 vom 17.03.2017
 * @author 
 */

public class Hauptfenster extends JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3449789944169784606L;
	// Anfang Attribute
	private JLabel lbTitel = new JLabel();
	private JLabel lbZeichenkette = new JLabel();
	private JTextField tfZeichenkette = new JTextField();
	private DefaultComboBoxModel<String> cbmSortieren;
	private Algorithmus derAlgorithmus = new Algorithmus(this);
	private final JLabel lblcon = new JLabel("");
	private final JTextArea taAusgabe = new JTextArea();
	private final JScrollPane scausgabe = new JScrollPane();
	private final JLabel lbSortieralgorithmus = new JLabel("Algorithmus w\u00E4hlen:");
	private final JSeparator separator = new JSeparator();
	private final JSeparator separator_1 = new JSeparator();
	private final JSeparator separator_2 = new JSeparator();
	
	// Ende Attribute

	public Hauptfenster(String title) { 
		// Frame-Initialisierung
		super(title);
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		setSize(519, 554);
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		int x = (d.width - getSize().width) / 2;
		int y = (d.height - getSize().height) / 2;
		setLocation(x, y);
		setResizable(false);
		Container cp = getContentPane();
		cp.setLayout(null);
		// Anfang Komponenten


		lbTitel.setBounds(16, 8, 272, 41);
		lbTitel.setText("Der Lokale Speicher");
		lbTitel.setFont(new Font("Dialog", Font.BOLD, 18));
		cp.add(lbTitel);
		lbZeichenkette.setBounds(16, 56, 241, 25);
		lbZeichenkette.setText("Eingabe einer beliebigen Zeichenkette:");
		cp.add(lbZeichenkette);
		tfZeichenkette.setBounds(29, 83, 421, 41);
		tfZeichenkette.setText("tfZeichenkette");
		tfZeichenkette.setBackground(new Color(0xC0C0C0));
		cp.add(tfZeichenkette);
		cp.setBackground(Color.WHITE);
		lblcon.setIcon(new ImageIcon(Hauptfenster.class.getResource("/klassen/images/logo_final.png")));
		lblcon.setBounds(281, 464, 175, 50);

		getContentPane().add(lblcon);

		JButton btTesten = new JButton("Algoritmus testen");
		btTesten.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				btTesten_ActionPerformed(evt);  		
			}
		});
		btTesten.setBounds(30, 234, 422, 33);
		getContentPane().add(btTesten);

		JComboBox<String> cbSortieren = new JComboBox<String>();
		cbmSortieren = new DefaultComboBoxModel<String>();
		cbmSortieren.addElement("Daten importieren");
		cbmSortieren.addElement("Daten exportieren");
		cbmSortieren.addElement("Daten anzeigen");
		cbmSortieren.addElement("Daten einfgen");
		cbmSortieren.addElement("Daten suchen");
		cbSortieren.setModel(cbmSortieren);
		cbSortieren.setBounds(30, 180, 421, 41);
		getContentPane().add(cbSortieren);
		scausgabe.setBounds(30, 298, 422, 112);

		getContentPane().add(scausgabe);
		taAusgabe.setText("taAusgabe");
		scausgabe.setViewportView(taAusgabe);
		lbSortieralgorithmus.setBounds(16, 148, 421, 25);

		getContentPane().add(lbSortieralgorithmus);
		separator.setBounds(16, 281, 447, 15);
		
		getContentPane().add(separator);
		separator_1.setBounds(16, 143, 449, 15);
		
		getContentPane().add(separator_1);
		separator_2.setBounds(12, 426, 447, 15);
		
		getContentPane().add(separator_2);
		// Ende Komponenten

		setVisible(true);
	} // end of public Hauptfenster

	// Anfang Methoden

	public static void main(String[] args) {
		new Hauptfenster("Algorithmen");
	} // end of main

	/*Ereignissteuerung Algorithmus Testen*/
	public void btTesten_ActionPerformed(ActionEvent evt) {
		//Eingabe
		leseZeichenkette();
		leseBezeichnung();

		//Verarbeitung
		derAlgorithmus.testen();
		
		//Ausgabe
		//siehe testen()

	} // end of btTesten_ActionPerformed

	private void leseBezeichnung(){
		derAlgorithmus.setBezeichnung(
				String.valueOf(
						cbmSortieren.getSelectedItem()));		
	}

	private void leseZeichenkette(){
		derAlgorithmus.setZeichenkette(
				String.valueOf(tfZeichenkette.getText()));		
	}

	public void schreibeAusgabe(){
		String newline ="\n";
		String tab ="\t";
		taAusgabe.setText(
				"Zeichenkette: "+tab+ derAlgorithmus.getZeichenkette()+newline
				+"Bezeichnung: "+tab+tab+derAlgorithmus.getBezeichnung()+newline
				+"Beschreibung: "+tab+tab+derAlgorithmus.getBeschreibung()+newline
				);

	}
	
	public void leereAusgabe(){
		taAusgabe.setText("");
	}

	public void schreibeDatensatz(String pDatensatz){	
		String newline = "\n";
		taAusgabe.append(pDatensatz+newline);	
	}	
	
	public void zeigeDialogfenster(String pMeldung){
		JOptionPane.showMessageDialog(null,pMeldung);
	}
	
} // end of class Hauptfenster
